<?php
if(!defined('IN_SEO'))
{
	define('IN_PHPBB', true);
	define('BB_SCRIPT', 'quote');
	define('BB_ROOT', './');
	require(BB_ROOT . "common.php");
}
$user->session_start();

if(!$bb_cfg['chat_on']) bb_die('Чат отключен');

$mode_start = (int) htmlspecialchars(request_var('start', ''));
$mode_id = (int) htmlspecialchars(request_var('id', ''));
$page_cfg['include_bbcode_js'] = true;

$groupOn = (isset($_GET['group_chat']) || isset($_POST['group_chat'])) ? true : false;
if($groupOn)
{
	$group = (!empty($_POST['group_chat'])) ? $_POST['group_chat'] : $_GET['group_chat'];
	if(!empty($group) && $group > 0)
	{
		$checkGroup = DB()->fetch_row("SELECT * FROM ".BB_CHAT_GROUP." WHERE group_id = {$group} LIMIT 1");
		if(count($checkGroup)<= 0)
		{
			bb_die('Такой группы не существует');
		}else{
			$groupSqlWhere = "
				WHERE c.group_id = $group
			";
			
			$groupNum = $checkGroup['group_id'];
		}
	}else{	
		bb_die('Такой группы не существует');
	}	
}else{
	$groupSqlWhere = "
		WHERE c.group_id = 1
	";
	$groupNum = "1";
}
if (!$group_chat = $datastore->get('group_chat'))
{
	$datastore->update('group_chat');
	$group_chat = $datastore->get('group_chat');
}
if($groupNum > 0)
{
	if (!$groupNum OR !$chat_data = @$group_chat['c'][$groupNum])
	{
		bb_die($lang['FORUM_NOT_EXIST']);
	}

	$is_auth_chat = $chat->auth(AUTH_ALL, $groupNum, $userdata, $chat_data);
	
	if (!$is_auth_chat['group_auth_view'])
	{
		$message = sprintf($lang['SORRY_AUTH_VIEW'], $is_auth_chat['group_auth_view_type']);
		bb_die($message);
	}
}

$url = 'chat.php?group_chat='.$groupNum.'';
$start = ($mode_start) ? $mode_start : 0;
$per_page = $bb_cfg['chat_message'];
$sql =  "SELECT COUNT(c.id) as count
	FROM ".BB_CHAT." c $groupSqlWhere";
if ( !($result = DB()->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not obtain '.$start.' information', '', __LINE__, __FILE__, $sql);
}
$row = DB()->sql_fetchrow($result);
$count = ( $row['count'] ) ? $row['count'] : 0;
if($groupNum > 0)
{
	if (!$group_chat = $datastore->get('group_chat'))
	{
		$datastore->update('group_chat');
		$group_chat = $datastore->get('group_chat');
	}
	if (!$groupNum OR !$chat_data = @$group_chat['c'][$groupNum])
	{
		bb_die($lang['FORUM_NOT_EXIST']);
	}

	$is_auth = $chat->auth(AUTH_ALL, $groupNum, $userdata, $chat_data);

	if (!$is_auth['group_auth_view'])
	{
		$message = sprintf($lang['SORRY_AUTH_VIEW'], $is_auth['group_auth_view_type']);
		bb_die($message);
	}
}

if($count > 0)
{
	if($mode_id)
	{
		$sql_ch = "SELECT c.*, u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt
			FROM ".BB_CHAT." c
			LEFT JOIN ". BB_USERS ." u ON(u.user_id = c.user_id)
			$groupSqlWhere
			AND c.id = $mode_id
			GROUP BY c.id DESC
			LIMIT 1";
		if (!($result = DB()->sql_query($sql_ch)))
		{
					message_die(GENERAL_ERROR, 'Could not obtain '.$start.' information', '', __LINE__, __FILE__, $sql_ch);
		}
		if(!($row_ch = DB()->fetch_row($sql_ch)))
		{
		   bb_die('Данного сообщения не существует');
		}
	}else{
		$sql_ch = "SELECT c.*, u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_gender
			FROM ".BB_CHAT." c
			LEFT JOIN ". BB_USERS ." u ON(u.user_id = c.user_id)
			$groupSqlWhere
			GROUP BY c.id DESC
			LIMIT $start, $per_page";
		if (!($result = DB()->sql_query($sql_ch)))
		{
			message_die(GENERAL_ERROR, 'Could not obtain '.$start.' information', '', __LINE__, __FILE__, $sql_ch);
		}
	}
	$row_ch = DB()->sql_fetchrowset($result);
	
	$moderation = (!empty($_REQUEST['mod']) && $is_auth['auth_mod']);

    foreach($row_ch as $row)
    {
		switch($row['user_gender']) 
		{ 
			case MALE: 
				$gender = '&nbsp;<b>&#0183;</b>&nbsp;<img src="'. $images['icon_male'] .'" alt="" title="'. $lang['GENDER_SELECT'][1] .'" border="0" />';
				break; 
			case FEMALE: 
				$gender = '&nbsp;<b>&#0183;</b>&nbsp;<img src="'. $images['icon_female'] .'" alt="" title="'. $lang['GENDER_SELECT'][2] .'" border="0" />';
				break; 
			default: 
				$gender = '';
				break;			
		}
		$profile_img = ($bb_cfg['text_buttons']) ? $lang['READ_PROFILE_TXTB'] : '<img src="'. $images['icon_profile'] .'" alt="'. $lang['READ_PROFILE_TXTB'] .'" title="'. $lang['READ_PROFILE'] .'" />';
		$pm_img = ($bb_cfg['text_buttons']) ? $lang['SEND_PM_TXTB'] : '<img src="'. $images['icon_pm'] .'" alt="'. $lang['SEND_PM_TXTB'] .'" title="'. $lang['SEND_PRIVATE_MESSAGE'] .'" />';
		$profile_url = ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '&nbsp;<b>&#0183;</b>&nbsp;<a href="'. PROFILE_URL . $row['user_id'].'">'.$profile_img.'</a>';
		$pm_url      = ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '&nbsp;<b>&#0183;</b>&nbsp;<a href="'. PM_URL .$row['user_id'].'">'.$pm_img.'</a>';
        $orig_word = array();
        $replacement_word = array();
        obtain_word_list($orig_word, $replacement_word);
        $messages = ($row['user_id'] == BOT_UID) ? $row['text_html'] : str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $row['text_html'] . '<'), 1, -1));
        $message = '<div class="post_body" style="margin: 0px"><div class="post_wrap">';
		$message .= '<div class="row1 chat-comment" id="pp_'. $row['id'] .'"><div style="min-height: 32px;">';
        $message .= ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '<a href="'. PROFILE_URL . $row['user_id'] .'">';
        $message .= str_replace('<img', '<img align="left" style="padding-right: 3px;"', get_avatar($row['user_avatar'], $row['user_avatar_type'], !bf($row['user_opt'], 'user_opt', 'allow_avatar'), '32', '32'));
        $message .= ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '</a>';
		$message .= ($row['user_id'] != BOT_UID && $is_auth_chat['group_auth_delete'] && ($row['user_id'] == $userdata['user_id'] || $is_auth_chat['group_chat_mod'] || IS_ADMIN)) ? '<input onclick="set_hid_chbox('. $row['id'] .');" class="floatR chat-post" type="checkbox" value="'. $row['id'] .'" />':'';
		$message .= ($row['user_id'] != BOT_UID && $is_auth_chat['group_auth_edit'] && ($row['user_id'] == $userdata['user_id'] || $is_auth_chat['group_chat_mod'] || IS_ADMIN)) ? '<span onclick="edit_comment('. $row['id'] .'); return false;" class="txtb floatR">[p]</span>': '';
        $title_ip = (IS_ADMIN) ? decode_ip($row['ip']) : 'Ник в чат';
		$message .= '<a href="#" class="bold" title="'. $title_ip .'" onclick="add_nick(\'[n]'. $row['username'] .'[/n]\'); return false;">'. str_replace('title="', 'data="', profile_url(array('username' => $row['username'], 'user_rank' => $row['user_rank']))) .'</a>'.$profile_url.$pm_url.$gender.'<div class="small">'. bb_date($row['time']) .'</div></div>';
        $message .= '<div class="spacer_2"></div><span style="font-size: 11px;">'. $messages .'</span></div>';
		$message .= ($row['user_id'] != BOT_UID && $is_auth_chat['group_auth_edit'] && ($row['user_id'] == $userdata['user_id'] || $is_auth_chat['group_chat_mod'] || IS_ADMIN)) ? '<span id="pe_'. $row['id'] .'"></span>' : '';					
        $message .= '</div></div>';
		
        $template->assign_block_vars('chat', array(
            'TEXT'        => $message,
        ));
    }
}else{
	$template->assign_block_vars('no_chat', array());
}
	$excluded_group_chat_csv = $user->get_excluded_group_chat(AUTH_VIEW);
	$whereSqlCG = ($excluded_group_chat_csv) ? "
		WHERE group_id NOT IN($excluded_group_chat_csv)
	" : '';


	$sql = 'SELECT group_id, group_name
		FROM '. BB_CHAT_GROUP ."
			$whereSqlCG
		ORDER BY group_order, group_id";

	if (!$result = DB()->sql_query($sql))
	{
		message_die(GENERAL_ERROR, "Couldn't get list of Categories".$excluded_group_chat_csv."", "", __LINE__, __FILE__, $sql);
	}
	$max_group_rows		= 100;
	$max_group_len		= 200;
	$rowset = DB()->sql_fetchrowset($result);

	$opt = '';
	$search_in_forums_fary = array();
	if ($groupOn)
	{
		if(isset($groupNum))
		{
			foreach ($rowset as $c_data_id)
			{
				$allowed_cat[] = $c_data_id['group_id'];
			}
			$categoryArr = (array) $groupNum;
			array_deep($categoryArr, 'intval');
			$valid_forums = array_intersect($categoryArr, $allowed_cat);
			$cat_val = join(',', $valid_forums);
		}else{
			$cat_val = '';
		}
		if ($cat_val)
		{
			$search_in_cat_ary  = explode(',', $cat_val);
			$search_in_cat_fary = array_flip($search_in_cat_ary);
		}
	}

	foreach ($rowset as $c_data)
	{
		$group_chat_name = $c_data['group_name'];
		$group_chat_name = str_short($group_chat_name, $max_group_len);
		$selected = (isset($search_in_cat_fary[$c_data['group_id']])) ? HTML_SELECTED : '';
		$opt .= '<option id="'. $c_data['group_id'] .'" value="'. $c_data['group_id'] .'"'. $selected .'>'. $group_chat_name ."&nbsp;</option>\n";
	}

	$catSelect = "\n".'<select class="textCtrl" name="group_chat">'. $opt ."</select>\n";
	$pagination = generate_pagination($url, $count, $per_page, $start, false, true);
	$template->assign_vars(array(
		'PAGINATION'		=> $pagination,
		'PAGE_NUMBER'		=> sprintf($lang['PAGE_OF'], ( floor( $start / $per_page ) + 1 ), ceil( $count / $per_page )),
		'U_PER_PAGE'		=> $url,
		'PER_PAGE'			=> $per_page,
		'S_FORM_ACTION'		=> $url,
        'GROUP_ID'			=> ($groupOn) ? $group : $groupNum,
		'GROUP_CHAT'		=> $catSelect,
        'CHAT_ID'			=> (int) @$row_ch[0]['id'],
        'CHAT_BBCODE_ON'	=> $bb_cfg['chat_bbcode_on'],
        'CHAT_ON'			=> $bb_cfg['chat_on'],
		'PAGE_TITLE'		=> $lang['CHAT_TITLE'],
	));
print_page('chat.tpl');
