<?php
// ACP Header - START
if (!empty($setmodules))
{
	$module['Mods']['CHAT_GROUP'] = basename(__FILE__);
	return;
}
$gen_simple_header = true;

require('./pagestart.php');

// ACP Header - END

require(INC_DIR  .'functions_group.php');
require(LANG_DIR .'lang_admin_bt.php');

$forum_auth_fields = array(
	'group_auth_view',
	'group_auth_reply',
	'group_auth_edit',
	'group_auth_delete',
);

$field_names = array();
foreach ($forum_auth_fields as $auth_type)
{
	$field_names[$auth_type] = $lang[strtoupper($auth_type)];
}

$forum_auth_levels = array('ALL',   'REG',    'PRIVATE', 'MOD',    'ADMIN');
$forum_auth_const  = array(AUTH_ALL, AUTH_REG, AUTH_ACL,  AUTH_MOD, AUTH_ADMIN);

$mode = (@$_REQUEST['mode']) ? (string) $_REQUEST['mode'] : '';

$cat_forums = $chat->get_cat();

if ($orphan_sf_sql = $chat->get_orphan_sf())
{
	$chat->fix_orphan_sf($orphan_sf_sql, TRUE);
}
$forum_parent = $cat_id = 0;
$forumname = '';

if (isset($_REQUEST['addcat']) || isset($_REQUEST['addcat']))
{
	$mode = (isset($_REQUEST['addcat'])) ? "addcat" : "addcat";

	if ($mode == 'addcat' && isset($_POST['addcat']) && isset($_POST['forumname']) && is_array($_POST['addcat']))
	{
		$req_cat_id = array_keys($_POST['addcat']);
		$cat_id = $req_cat_id[0];
		$forumname = stripslashes($_POST['forumname'][$cat_id]);
	}
}

$show_main_page = false;

if ($mode)
{
	switch ($mode)
	{
		case 'addcat':
		case 'editcat':
			$s_column_span = 0;
			if ($mode == 'editcat')
			{

				$l_title = $lang['EDIT_FORUM'];
				$newmode = 'modcat';
				$buttonvalue = $lang['UPDATE'];

				$forum_id = intval($_GET[POST_FORUM_URL]);

				$row = $chat->get_info($forum_id);

				$forumname = $row['group_name'];
				$forumdesc = $row['group_desc'];
				$forum_status = $row['group_status'];
				$forum_rows = $chat->get_info($forum_id);
			}else{
				$l_title = $lang['CREATE_FORUM'];
				$newmode = 'createcat';
				$buttonvalue = $lang['CREATE_FORUM'];

				$forumdesc = '';
				$forum_status = FORUM_UNLOCKED;
				$forum_id = '';
				$forum_rows = "SELECT *
					FROM ".BB_CHAT_GROUP."";
			}
				for($j = 0; $j < count($forum_auth_fields); $j++)
				{
					$custom_auth[$j] = '&nbsp;<select name="' . $forum_auth_fields[$j] . '">';
					$custom_auth[$j] .= '<optgroup label="&nbsp;'. $field_names[$forum_auth_fields[$j]] .'">';

					for($k = 0; $k < count($forum_auth_levels); $k++)
					{
						$selected = ( $forum_rows[$forum_auth_fields[$j]] == $forum_auth_const[$k] ) ? ' selected="selected"' : '';
						$custom_auth[$j] .= '<option value="' . $forum_auth_const[$k] . '"' . $selected . '>' . $lang['FORUM_' . strtoupper($forum_auth_levels[$k])] . '</OPTION>';
					}
					$custom_auth[$j] .= '</optgroup>';
					$custom_auth[$j] .= '</select>&nbsp;';

					$template->assign_block_vars('forum_auth', array(
						'S_AUTH_LEVELS_SELECT' => $custom_auth[$j],
					));

					$s_column_span++;
				}

			$forumlocked = $forumunlocked = '';

			$forum_status == ( FORUM_LOCKED ) ? $forumlocked = "selected=\"selected\"" : $forumunlocked = "selected=\"selected\"";

			// These two options ($lang['STATUS_UNLOCKED'] and $lang['STATUS_LOCKED']) seem to be missing from
			// the language files.
			$lang['STATUS_UNLOCKED'] = isset($lang['STATUS_UNLOCKED']) ? $lang['STATUS_UNLOCKED'] : 'Unlocked';
			$lang['STATUS_LOCKED'] = isset($lang['STATUS_LOCKED']) ? $lang['STATUS_LOCKED'] : 'Locked';

			$statuslist = "<option value=\"" . FORUM_UNLOCKED . "\" $forumunlocked>" . $lang['STATUS_UNLOCKED'] . "</option>\n";
			$statuslist .= "<option value=\"" . FORUM_LOCKED . "\" $forumlocked>" . $lang['STATUS_LOCKED'] . "</option>\n";

			$s_hidden_fields = '<input type="hidden" name="mode" value="' . $newmode .'" /><input type="hidden" name="' . POST_FORUM_URL . '" value="' . $forum_id . '" />';
			
			$opt = '';
			$g_sql = DB()->fetch_rowset("SELECT group_id, group_name FROM ". BB_GROUPS ." WHERE group_single_user = 0 ORDER BY group_name");
			if (isset($_POST['group_dost']))
			{
				$groupArr = $_POST['group_dost'];
				if(int_check($groupArr, true))
				{
					foreach ($g_sql as $g_data_id)
					{
						$allowed_g[] = $g_data_id['group_id'];
					}
					$groupArr = (array) $groupArr;
					array_deep($groupArr, 'intval');
					$valid_group = array_intersect($groupArr, $allowed_g);
					$g_val = join(',', $valid_group);
				}
				if ($cat_val)
				{
					$search_in_g_ary  = array_slice(explode(',', $g_val), 0);
					$search_in_g_fary = array_flip($search_in_g_ary);
				}
			}
			foreach ($g_sql as $g_data)
			{
				//$opt .= '<optgroup label="&nbsp;'. $g_data['blog_section_name'] ."\">\n";
					$group_name = $g_data['group_name'];
					$selected = (isset($search_in_g_fary[$g_data['group_id']])) ? HTML_SELECTED : '';
					$opt .= '<option id="'. $g_data['group_id'] .'" value="'. $g_data['group_id'] .'"'. $selected .'>'. $group_name ."&nbsp;</option>\n";
				//$opt .= "</optgroup>\n";
			}

			$gSelect = "\n".'<select class="textCtrl" style="width: 100%;" name="group_dost[]" multiple="multiple" size="'.min(5, count($g_sql))."\">\n". $opt ."</select>\n";

			$template->assign_vars(array(
				'TPL_EDIT_FORUM' => true,

				'S_FORUM_ACTION' => 'admin_chat_group.php',
				'S_HIDDEN_FIELDS' => $s_hidden_fields,
				'S_SUBMIT_VALUE' => $buttonvalue,
				'S_STATUS_LIST' => $statuslist,

				'L_FORUM_TITLE' => $l_title,

				'FORUM_NAME' => htmlCHR($forumname),
				'DESCRIPTION' => htmlCHR($forumdesc),
				'S_GROUP_SELECT'   => $gSelect,
			));
			break;

		case 'createcat':
			//
			// Create a forum in the DB
			//
			$forum_name = DB()->escape(trim($_POST['forumname']));
			$forum_status = intval($_POST['forumstatus']);
			$forum_desc = DB()->escape(trim($_POST['forumdesc']));
			
			if (!$forum_name)
			{
				message_die(GENERAL_ERROR, "Can't create a forum without a name");
			}


			// Default permissions of public forum
			$field_sql = $value_sql = '';

			for($i = 0; $i < count($forum_auth_fields); $i++)
			{
				$value = intval($_POST[$forum_auth_fields[$i]]);

				if ( $forum_auth_fields[$i] == 'auth_vote' )
				{
					if ( $_POST['auth_vote'] == AUTH_ALL )
					{
						$value = AUTH_REG;
					}
				}

				$field_sql .= ( ( $field_sql != '' ) ? ', ' : '' ) .$forum_auth_fields[$i];
				$value_sql .= ( ( $value_sql != '' ) ? ', ' : '' ) .$value;
			}

			$columns = ' group_name, group_desc, group_status, '. $field_sql;
			$values = "'$forum_name', '$forum_desc', $forum_status, ". $value_sql;

			DB()->query("INSERT INTO ". BB_CHAT_GROUP ." ($columns) VALUES ($values)");

			$datastore->update('group_chat');

			$message = $lang['FORUMS_UPDATED'] . "<br /><br />" . sprintf($lang['CLICK_RETURN_FORUMADMIN'], "<a href=\"" . "admin_chat_group.php" . "\">", "</a>") . "<br /><br />" . sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], "<a href=\"index.php?pane=right\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);

			break;

		case 'modcat':
			//
			// Modify a forum in the DB
			//
			$forum_id = intval($_POST[POST_FORUM_URL]);
			$forum_name = DB()->escape(trim($_POST['forumname']));
			$forum_desc = DB()->escape(trim($_POST['forumdesc']));
			$forum_status = intval($_POST['forumstatus']);

			if (!$forum_name)
			{
				message_die(GENERAL_ERROR, "Can't modify a forum without a name");
			}
			$sql_autch = '';
			for($i = 0; $i < count($forum_auth_fields); $i++)
			{
				$value = intval($_POST[$forum_auth_fields[$i]]);

				if ( $forum_auth_fields[$i] == 'auth_vote' )
				{
					if ( $_POST['auth_vote'] == AUTH_ALL )
					{
						$value = AUTH_REG;
					}
				}

				$sql_autch .= ( ( $sql_autch != '' ) ? ', ' : '' ) .$forum_auth_fields[$i] . ' = ' . $value;
			}


			DB()->query("
				UPDATE ". BB_CHAT_GROUP ." SET
					group_name			= '$forum_name',
					group_desc			= '$forum_desc',
					group_status			= $forum_status,
					$sql_autch
				WHERE group_id			= $forum_id
			");


			//$datastore->update('cat_forums');

			$message = $lang['FORUMS_UPDATED'] . "<br /><br />";
			$message .= sprintf($lang['CLICK_RETURN_FORUMADMIN'], "<a href=\"" . "admin_chat_group.php?c=$cat_id" . "\">", "</a>") . "<br /><br />" . sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], "<a href=\"index.php?pane=right\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);

			break;


		case 'deletecat':
			//
			// Show form to delete a forum
			//
			$forum_id = (int) $_GET['f'];
			if($forum_id == '1')
			{
				$message = 'Удаление данной котегории не возможно <br /><br />' . sprintf($lang['CLICK_RETURN_FORUMADMIN'], "<a href=\"" . "admin_chat_group.php" . "\">", "</a>") . "<br /><br />" . sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], "<a href=\"index.php?pane=right\">", "</a>");
				message_die(GENERAL_MESSAGE, $message);
			}
			if($forum_id)
			{
				$sql = "DELETE FROM " . BB_CHAT_GROUP . "
					WHERE group_id = $forum_id";
			
				if( !$result = DB()->sql_query($sql) )
				{
					message_die(GENERAL_ERROR, "Couldn't delete chat data", "", __LINE__, __FILE__, $sql);
				}
				$datastore->update('group_chat');

				$message = 'Категория удалена' . "<br /><br />" . sprintf('Нажмите сюда для перехода к управлению категориями', "<a href=\"admin_chat_group.php\">", "</a>") . "<br /><br />" . sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], '<a href="index.php?pane=right">', '</a>');

				message_die(GENERAL_MESSAGE, $message);

			}
			else
			{
				message_die(GENERAL_MESSAGE, 'Категория не была выбрана');
			}

			break;

		case 'cat_order':
			$forum_id = intval($_GET[POST_FORUM_URL]);

			$move = intval($_GET['move']);
			$sql = "UPDATE " . BB_CHAT_GROUP . "
				SET group_order = group_order + $move
				WHERE group_id = $forum_id";
			if( !$result = DB()->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't change chat category order", "", __LINE__, __FILE__, $sql);
			}

			$chat->renumber_order('category');
			//$datastore->update('group_chat');
			$show_main_page = TRUE;
			
			break;

		default:
			message_die(GENERAL_MESSAGE, $lang['NO_MODE']);

			break;
	}
}

if (!$mode || $show_main_page)
{
	$template->assign_vars(array(
		'TPL_FORUMS_LIST' => true,

		'S_FORUM_ACTION' => "admin_chat_group.php",
		'L_FORUM_TITLE' => $lang['FORUM_ADMIN_MAIN']
	));

	$sql = DB()->fetch_rowset("SELECT *
		FROM " . BB_CHAT_GROUP . "
		ORDER BY group_order");
		
	$i = 0;

	if(count($sql)>0)
	{
		$gen_cat = array();

		$bgr_class_1    = 'row1';
		$bgr_class_2    = 'row2';
		$bgr_class_over = 'row3';

			foreach($sql as $rows)
			{
				$cat_id = $rows['group_id'];
				$i++;
				$bgr_class = (!($i % 2)) ? $bgr_class_2 : $bgr_class_1;
				$row_bgr   = " class=\"$bgr_class\" onmouseover=\"this.className='$bgr_class_over';\" onmouseout=\"this.className='$bgr_class';\"";

					$template->assign_block_vars("catrow",	array(
						'FORUM_NAME'		=> htmlCHR($rows['group_name']),
						'FORUM_DESC'		=> htmlCHR($rows['group_desc']),
						'NUM_POSTS'			=> $rows['group_posts'],

						'FORUM_ID'			=> $rows['group_id'],
						'DELETE'			=> ($rows['group_id']=='1') ? false : true,
						'ROW_BGR'			=> $row_bgr,

						'U_VIEWFORUM'       => BB_ROOT ."chat.php?group_chat=$cat_id",
						'U_FORUM_EDIT'      => "admin_chat_group.php?mode=editcat&amp;f=$cat_id",
						'U_FORUM_DELETE'    => "admin_chat_group.php?mode=deletecat&amp;f=$cat_id",
						'U_FORUM_MOVE_UP'   => "admin_chat_group.php?mode=cat_order&amp;move=-15&amp;f=$cat_id",
						'U_FORUM_MOVE_DOWN' => "admin_chat_group.php?mode=cat_order&amp;move=15&amp;f=$cat_id",
					));
			}
	}
}

print_page('admin_chat_group.tpl', 'admin');
