<?php

if (!defined('IN_AJAX')) die(basename(__FILE__));

global $bb_cfg, $userdata, $datastore, $lang, $chat, $images;

$mode = (string) $this->request['mode'];
$group = (int) @$this->request['group'];

function parse_username($username)
{
	$username = $username[1];
	$username = '<span class="post-b">'. $username .'</span>, ';
	
	return $username;
}
if(isset($group) && $group > 0)
{
	$checkGroup = DB()->fetch_row("SELECT * FROM ".BB_CHAT_GROUP." WHERE group_id = {$group} LIMIT 1");
	if(!$checkGroup)
	{
		$this->ajax_die('Такой группы не существует');
	}else{
		$groupSqlWhere = "
			WHERE c.group_id = $group
		";
		$MaxGroupSqlWhere = "
			WHERE group_id = $group
		";
		$groupSqlAnd = "
			AND c.group_id = $group
		";
		
		$groupNum = $groupSql = $group;
	}
}else{	
	$this->ajax_die('Такой группы не существует');
}	

if (!$group_chat = $datastore->get('group_chat'))
{
	$datastore->update('group_chat');
	$group_chat = $datastore->get('group_chat');
}

if($groupNum > 0)
{
	if (!$groupNum OR !$chat_data = @$group_chat['c'][$groupNum])
	{
		$this->ajax_die($lang['FORUM_NOT_EXIST']);
	}

	$is_auth = $chat->auth(AUTH_ALL, $groupNum, $userdata, $chat_data);
}
switch($mode)
{
	case 'select':
		if (!$is_auth['group_auth_view'])
		{
			$message = sprintf($lang['SORRY_AUTH_VIEW'], $is_auth['group_auth_view_type']);
			$this->ajax_die($message);
		}
	break;

	case 'insert':
		if (!$is_auth['group_auth_reply'])
		{
			$message = sprintf($lang['SORRY_AUTH_REPLY'], $is_auth['group_auth_reply_type']);
			$this->ajax_die($message);
		}
		else if(bf($userdata['user_opt'], 'user_opt', 'allow_post'))
		{
			$this->ajax_die($lang['RULES_REPLY_CANNOT']);
		}
	break;

	case 'delete':
		$ids = (string) $this->request['ids'];
		if (!$is_auth['group_auth_delete'])
		{
			$message = sprintf($lang['SORRY_AUTH_DELETE'], $is_auth['group_auth_delete_type']);
			$this->ajax_die($message);
		}
		$row = DB()->fetch_row("SELECT * FROM ".BB_CHAT." WHERE id IN({$ids}) LIMIT 1");
		if(!$row)
		{
			$this->ajax_die('No message');
		}else{
			if ($row['user_id'] != $userdata['user_id'] && !$is_auth['group_chat_mod'] && $row['time'] + 3600*3 > TIMENOW)
			{
				$this->ajax_die($lang['EDIT_OWN_POSTS']);
			}
		}	
	break;

	case 'edit':
		$post_id = (int) $this->request['post_id'];
		if (!$is_auth['group_auth_edit'])
		{
			$message = sprintf($lang['SORRY_AUTH_EDIT'], $is_auth['group_auth_edit_type']);
			$this->ajax_die($message);
		}
		$row = DB()->fetch_row("SELECT * FROM ".BB_CHAT." WHERE id = {$post_id} LIMIT 1");
		if(!$row)
		{
			$this->ajax_die('No message');
		}else{
			if ($row['user_id'] != $userdata['user_id'] && !$is_auth['group_chat_mod'])
			{
				$this->ajax_die($lang['EDIT_OWN_POSTS']);
			}
		}	
	break;
}

switch($mode)
{
	case 'select':
		$id = (int) @$this->request['id'];
		$up = (int) @$this->request['up'];
		$lastgroup = (int) @$this->request['lastgroup'];
		
		if(''.$groupNum.'' == ''.$lastgroup.'')
		{
			$this->response['update'] = false;
		}else{
			$id = "0";
			$up = "0";
			$this->response['update'] = true;
		}
		$max_id = (int) DB()->fetch_row('SELECT MAX(id) as max_id FROM '.BB_CHAT.' '.$MaxGroupSqlWhere.'', 'max_id');
		if(!$id) $id = $max_id - $bb_cfg['chat_message'];
		if($id < 0) $id = 0;

		$message = '';
		if($id < $max_id)
		{
			if (!$sql = CACHE('bb_cache')->get('chat['.$groupNum.']'))
			{
				$sql = DB()->fetch_rowset("SELECT c.*, u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_gender
					FROM ".BB_CHAT." c
					LEFT JOIN ". BB_USERS ." u ON(u.user_id = c.user_id)
					$groupSqlWhere
					ORDER BY c.id DESC
					LIMIT {$bb_cfg['chat_message']}");
				CACHE('bb_cache')->set('chat['.$groupNum.']', $sql);
			}

			foreach($sql as $row)
			{
				if(($row['id'] > $id) && ($row['id'] <= $max_id))
				{
					switch($row['user_gender']) 
					{ 
						case MALE: 
							$gender = '&nbsp;<b>&#0183;</b>&nbsp;<img src="'. $images['icon_male'] .'" alt="" title="'. $lang['GENDER_SELECT'][1] .'" border="0" />';
							break; 
						case FEMALE: 
							$gender = '&nbsp;<b>&#0183;</b>&nbsp;<img src="'. $images['icon_female'] .'" alt="" title="'. $lang['GENDER_SELECT'][2] .'" border="0" />';
							break; 
						default: 
							$gender = '';
							break;			
					}
					$profile_img = ($bb_cfg['text_buttons']) ? $lang['READ_PROFILE_TXTB'] : '<img src="'. $images['icon_profile'] .'" alt="'. $lang['READ_PROFILE_TXTB'] .'" title="'. $lang['READ_PROFILE'] .'" />';
					$pm_img = ($bb_cfg['text_buttons']) ? $lang['SEND_PM_TXTB'] : '<img src="'. $images['icon_pm'] .'" alt="'. $lang['SEND_PM_TXTB'] .'" title="'. $lang['SEND_PRIVATE_MESSAGE'] .'" />';
					$profile_url = ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '&nbsp;<b>&#0183;</b>&nbsp;<a href="'. PROFILE_URL . $row['user_id'].'">'.$profile_img.'</a>';
					$pm_url      = ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '&nbsp;<b>&#0183;</b>&nbsp;<a href="'. PM_URL .$row['user_id'].'">'.$pm_img.'</a>';

					$orig_word = array();
					$replacement_word = array();
					obtain_word_list($orig_word, $replacement_word);
					$messages = ($row['user_id'] == BOT_UID) ? $row['text_html'] : str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $row['text_html'] . '<'), 1, -1));
					$message .= '<div class="post_body" style="margin: 0px"><div class="post_wrap">';
					$message .= '<div class="row1 chat-comment" id="pp_'. $row['id'] .'"><div style="min-height: 32px;">';
					$message .= ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '<a href="'. make_url(PROFILE_URL . $row['user_id']) .'">';
					$message .= str_replace('<img', '<img align="left" style="padding-right: 3px;"', get_avatar($row['user_avatar'], $row['user_avatar_type'], !bf($row['user_opt'], 'user_opt', 'allow_avatar'), '32', '32'));
					$message .= ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '</a>';
					$message .= ($row['user_id'] != BOT_UID && $is_auth['group_auth_delete'] && ($row['user_id'] == $userdata['user_id'] || $is_auth['group_chat_mod'] || IS_ADMIN)) ? '<input onclick="set_hid_chbox('. $row['id'] .');" class="floatR chat-post" type="checkbox" value="'. $row['id'] .'" />':'';
					$message .= ($row['user_id'] != BOT_UID && $is_auth['group_auth_edit'] && ($row['user_id'] == $userdata['user_id'] || $is_auth['group_chat_mod'] || IS_ADMIN)) ? '<span onclick="edit_comment('. $row['id'] .'); return false;" class="txtb floatR">[p]</span>': '';
					$title_ip = (IS_ADMIN) ? decode_ip($row['ip']) : 'Ник в чат';
					$message .= '<a href="#" class="bold" title="'. $title_ip .'" onclick="add_nick(\'[n]'. $row['username'] .'[/n]\'); return false;">'. str_replace('title="', 'data="', profile_url(array('username' => $row['username'], 'user_rank' => $row['user_rank']))) .'</a>'.$profile_url.$pm_url.$gender.'<div class="small">'. bb_date($row['time']) .'</div></div>';
					$message .= '<div class="spacer_2"></div><span style="font-size: 11px;">'. $messages .'</span></div>';
				    $message .= ($row['user_id'] != BOT_UID && $is_auth['group_auth_edit'] && ($row['user_id'] == $userdata['user_id'] || $is_auth['group_chat_mod'] || IS_ADMIN)) ? '<span id="pe_'. $row['id'] .'"></span>' : '';					
					$message .= '</div></div>';
				}
			}

			$this->response['up']      = $up;
			$this->response['id']      = (int) @$sql[0]['id'];
			$this->response['message'] = $message;
			$this->response['group']   = $group;
			$this->response['lastgroup'] = $group;
			$this->response['insert'] = true;
			$this->response['post_id'] = $max_id;		
		}else{
			$this->response['up']      = $up;
			$this->response['id']      = (int) @$sql[0]['id'];
			$this->response['message'] = $message;
			$this->response['group']   = $group;
			$this->response['lastgroup'] = $group;
		}
	break;

	case 'insert':
		$message = $this->request['message'];
		if(!trim($message)) $this->ajax_die('Нахер постить пустое сообщение?');

		$row = DB()->fetch_row("SELECT * FROM ".BB_CHAT." ORDER BY id DESC");
		if($row['text'] == $message) $this->ajax_die('Дабл пост.');
		if($row['user_id'] == $userdata['user_id'])
		{
			if($row['time'] > (TIMENOW - 5)) $this->ajax_die('Тайм флуд.');
		}
		
		$text_html = ($bb_cfg['chat_bbcode_on']) ? bbcode2html(prepare_message($message)) : bbcode_chat(prepare_message($message));
		$text_html = preg_replace_callback("/\[n\](.*?)\[\/n\]/siu", 'parse_username', $text_html);

		DB()->query("INSERT INTO ".BB_CHAT." (group_id, user_id, time, text, text_html, ip) VALUES ('{$groupSql}','{$userdata['user_id']}', '". TIMENOW ."', '". DB()->escape($message) ."', '". DB()->escape($text_html) ."', '". USER_IP ."')");

		$sql = DB()->fetch_rowset("SELECT c.*, u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_gender
			FROM ".BB_CHAT." c
			LEFT JOIN ". BB_USERS ." u ON(u.user_id = c.user_id)
			$groupSqlWhere
			ORDER BY c.id DESC
			LIMIT {$bb_cfg['chat_message']}");
		CACHE('bb_cache')->set('chat['.$groupNum.']', $sql);

        $this->response['id']    = (int) @$sql[0]['id'];
		$this->response['clear'] = true;
	break;

	case 'delete':
		$ids = (string) $this->request['ids'];

		DB()->query("DELETE FROM ".BB_CHAT." WHERE id IN($ids)");

		$sql = DB()->fetch_rowset("SELECT c.*, u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_gender
			FROM ".BB_CHAT." c
			LEFT JOIN ". BB_USERS ." u ON(u.user_id = c.user_id)
			$groupSqlWhere
			ORDER BY c.id DESC
			LIMIT {$bb_cfg['chat_message']}");
		CACHE('bb_cache')->set('chat['.$groupNum.']', $sql);

        $this->response['id']       = (int) @$sql[0]['id'];
		$this->response['del']      = explode(',', $ids);
	break;

	case 'edit':
	    $post_id = (int) $this->request['post_id'];
		$text    = (string) @$this->request['text'];
		$type    = (int) @$this->request['type'];		

		$row = DB()->fetch_row("SELECT
			c.*, u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_gender
			FROM ".BB_CHAT." c
			LEFT JOIN ". BB_USERS ." u ON(u.user_id = c.user_id)
			WHERE c.id = $post_id 
			$groupSqlAnd
			LIMIT 1");
	    if(!$row) $this->ajax_die('Нет поста');

		if($type)
		{
			if(mb_strlen($text) > 2)
			{
				$text_html = ($bb_cfg['chat_bbcode_on']) ? bbcode2html(prepare_message($text)) : bbcode_chat(prepare_message($text));
				$text_html = preg_replace_callback("/\[n\](.*?)\[\/n\]/siu", 'parse_username', $text_html);

				if($text != $row['text'])
				{
					DB()->query("UPDATE ".BB_CHAT." SET text = '". DB()->escape($text) ."', text_html = '". DB()->escape($text_html) ."' WHERE id = $post_id LIMIT 1");
				    $sql = DB()->fetch_rowset("SELECT c.*, u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt, u.user_gender
						FROM ".BB_CHAT." c
						LEFT JOIN ". BB_USERS ." u ON(u.user_id = c.user_id)
						$groupSqlWhere
						ORDER BY c.id DESC
						LIMIT {$bb_cfg['chat_message']}");
					CACHE('bb_cache')->set('chat['.$groupNum.']', $sql);
				}
			}else{
				$this->ajax_die('Слишком короткое сообщение.');
			}	
			switch($row['user_gender']) 
			{ 
				case MALE: 
					$gender = '&nbsp;<b>&#0183;</b>&nbsp;<img src="'. $images['icon_male'] .'" alt="" title="'. $lang['GENDER_SELECT'][1] .'" border="0" />';
					break; 
				case FEMALE: 
					$gender = '&nbsp;<b>&#0183;</b>&nbsp;<img src="'. $images['icon_female'] .'" alt="" title="'. $lang['GENDER_SELECT'][2] .'" border="0" />';
					break; 
				default: 
					$gender = '';
					break;			
			}
			$profile_img = ($bb_cfg['text_buttons']) ? $lang['READ_PROFILE_TXTB'] : '<img src="'. $images['icon_profile'] .'" alt="'. $lang['READ_PROFILE_TXTB'] .'" title="'. $lang['READ_PROFILE'] .'" />';
			$pm_img = ($bb_cfg['text_buttons']) ? $lang['SEND_PM_TXTB'] : '<img src="'. $images['icon_pm'] .'" alt="'. $lang['SEND_PM_TXTB'] .'" title="'. $lang['SEND_PRIVATE_MESSAGE'] .'" />';
			$profile_url = ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '&nbsp;<b>&#0183;</b>&nbsp;<a href="'. PROFILE_URL . $row['user_id'].'">'.$profile_img.'</a>';
			$pm_url      = ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '&nbsp;<b>&#0183;</b>&nbsp;<a href="'. PM_URL .$row['user_id'].'">'.$pm_img.'</a>';
			$orig_word = array();
			$replacement_word = array();
			obtain_word_list($orig_word, $replacement_word);
			
			$messages = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $text_html . '<'), 1, -1));
			$message = '<div class="post_body" style="margin: 0px"><div class="post_wrap">';
			$message .= '<div style="min-height: 32px;">';
			$message .= ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '<a href="'. make_url(PROFILE_URL . $row['user_id']) .'">';
			$message .= str_replace('<img', '<img align="left" height="32" width="32" style="padding-right: 3px;"', get_avatar($row['user_avatar'], $row['user_avatar_type'], !bf($row['user_opt'], 'user_opt', 'allow_avatar')));
			$message .= ($row['user_id'] == ANONYMOUS || $row['user_id'] == BOT_UID) ? '' : '</a>';
			$message .= ($is_auth['group_auth_delete'] && ($row['user_id'] == $userdata['user_id'] || $is_auth['group_chat_mod'] || IS_ADMIN)) ? '<input onclick="set_hid_chbox('. $row['id'] .');" class="floatR chat-post" type="checkbox" value="'. $row['id'] .'" />':'';
			$message .= ($is_auth['group_auth_edit'] && ($row['user_id'] == $userdata['user_id'] || $is_auth['group_chat_mod'] || IS_ADMIN)) ? '<span onclick="edit_comment('. $row['id'] .'); return false;" class="txtb floatR">[p]</span>': '';
			$title_ip = (IS_ADMIN) ? decode_ip($row['ip']) : 'Ник в чат';
			$message .= '<a href="#" class="bold" title="'. $title_ip .'" onclick="add_nick(\'[n]'. $row['username'] .'[/n]\'); return false;">'. str_replace('title="', 'data="', profile_url(array('username' => $row['username'], 'user_rank' => $row['user_rank']))) .'</a>'.$profile_url.$pm_url.$gender.'<div class="small">'. bb_date($row['time']) .'</div></div>';
			$message .= '<div class="spacer_2"></div><span style="font-size: 11px;">'. $messages .'</span></div>';
			$message .= '</div></div>';

			$this->response['html'] = $message;
		}
		else
		{
			$message = '<form id="QuickChatEdit" name="post"><div class="tCenter chat-comment med">';
			$message .= ($bb_cfg['chat_bbcode_on']) ? '
				<div class="buttons mrg_4">
					<input type="button" value="B" name="codeB" title="'.$lang['BOLD'].'" style="font-weight: bold; width: 30px;" />
					<input type="button" value="i" name="codeI" title="'.$lang['ITALIC'].'" style="width: 30px; font-style: italic;" />
					<input type="button" value="u" name="codeU" title="'.$lang['UNDERLINE'].'" style="width: 30px; text-decoration: underline;" />
					<input type="button" value="s" name="codeS" title="'.$lang['STRIKEOUT'].'" style="width: 30px; text-decoration: line-through;" />&nbsp;&nbsp;
					<input type="button" value="'.$lang['QUOTE'].'" name="codeQuote" title="'.$lang['QUOTE_TITLE'].'" style="width: 57px;" />
					<input type="button" value="Img" name="codeImg" title="'.$lang['IMG_TITLE'].'" style="width: 40px;" />
					<input type="button" value="'.$lang['URL'].'" name="codeUrl" title="'.$lang['URL_TITLE'].'" style="width: 63px; text-decoration: underline;" /><input type="hidden" name="codeUrl2" />&nbsp;
					<input type="button" value="'.$lang['CODE'].'" name="codeCode" title="'.$lang['CODE_TITLE'].'" style="width: 43px;" />
					<input type="button" value="'.$lang['LIST'].'" name="codeList" title="'.$lang['LIST_TITLE'].'" style="width: 60px;" />
					<input type="button" value="1." name="codeOpt" title="'.$lang['LIST_ITEM'].'" style="width: 30px;" />&nbsp;
					<input type="button" value="'.$lang['QUOTE_SEL'].'" name="quoteselected" title="'.$lang['QUOTE_SELECTED'].'" onmouseout="bbcode.refreshSelection(false);" onmouseover="bbcode.refreshSelection(true);" onclick="bbcode.onclickQuoteSel();" />&nbsp;
				</div>
				' : '';
			$message .= '
				<textarea id="text-'. $post_id .'" style="height: 60px;" class="editor w90">'. $row['text'] .'</textarea>
				<div class="buttons mrg_4 tCenter">
					<input type="button" value="Изменить" onclick="edit_comment('. $post_id .', $(\'#text-'. $post_id .'\').val(), 1); return false;" /> &middot;
					<input type="button" value="Отмена" onclick="edit_comment('. $post_id .'); return false;" />
				</div>
				';
			$message .= ($bb_cfg['chat_bbcode_on']) ? '
				<script type="text/javascript">
					var bbcode = new BBCode("text-'. $post_id .'");
					var ctrl = "ctrl";

					bbcode.addTag("codeB", "b", null, "B", ctrl);
					bbcode.addTag("codeI", "i", null, "I", ctrl);
					bbcode.addTag("codeU", "u", null, "U", ctrl);
					bbcode.addTag("codeS", "s", null, "S", ctrl);

					bbcode.addTag("codeQuote", "quote", null, "Q", ctrl);
					bbcode.addTag("codeImg", "img", null, "R", ctrl);
					bbcode.addTag("codeUrl", "url", "/url", "", ctrl);
					bbcode.addTag("codeUrl2", "url=", "/url", "W", ctrl);

					bbcode.addTag("codeCode", "code", null, "K", ctrl);
					bbcode.addTag("codeList",  "list", null, "L", ctrl);
					bbcode.addTag("codeOpt", "*", "", "0", ctrl);
				</script>
				' : '';
			$message .= '</div></form>';
			
			$this->response['text'] = $message;
		}

		$this->response['post_id'] = $post_id;
	break;
}